#!/usr/bin/env python
# -*- coding: utf-8 -*-
try:
    import __builtin__  as __builtins__ # python 2
except:
    import builtins as __builtins__ # python 3
from dict import *
from public import *

@public
class idict(dict):
    def has_key(self,key):
        if key in self.keys(): return True
        if key in self.lower_keys(): return True
        if key in self.upper_keys(): return True
        return False

    def lower_keys(self):
        return list(map(lambda k:k.lower(),self.keys()))

    def upper_keys(self):
        return list(map(lambda k:k.upper(),self.keys()))

    def key_case(self, key):
        for k in self.keys():
            if key.lower()==k.lower():
                return k
        return key

    def __contains__(self, item):
        return item.lower() in self.lower_keys()

    def __delitem__(self,key):
        if key is None:
            return
        if key.lower() in self.lower_keys():
            key = self.key_case(key)
            __builtins__.dict.__delitem__(self,key)

    def __getitem__(self,key):
        key = self.key_case(key)
        return __builtins__.dict.__getitem__(self,key)

if __name__=="__main__":
    dict = idict(K="v")
    print("keys(): %s" % dict.keys())
    print("lower_keys(): %s" % dict.lower_keys())
    print("upper_keys(): %s" % dict.upper_keys())
    assert "k" in dict
    assert dict["k"]==dict["K"]
    del dict["k"]
    assert "k" not in dict
    assert "K" not in dict
